<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (41)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="array-methods">Array methods</h1>
    <p>
      Arrays provide a lot of methods. To make things easier, in this chapter
      they are split into groups.
    </p>
    <h2 id="addremove-items">Add/remove items</h2>
    <p>
      We already know methods that add and remove items from the beginning or
      the end:
    </p>
    <ul>
      <li><code>arr.push(...items)</code> – adds items to the end,</li>
      <li><code>arr.pop()</code> – extracts an item from the end,</li>
      <li><code>arr.shift()</code> – extracts an item from the beginning,</li>
      <li><code>arr.unshift(...items)</code> – adds items to the beginning.</li>
    </ul>
    <p>Here are a few others.</p>
    <h3 id="splice">splice</h3>
    <p>How to delete an element from the array?</p>
    <p>The arrays are objects, so we can try to use <code>delete</code>:</p>
    <p>```js run let arr = [“I”, “go”, “home”];</p>
    <p>delete arr[1]; // remove “go”</p>
    <p>alert(arr[1]); // undefined</p>
    <p>// now arr = [“I”, , “home”]; alert(arr.length); // 3 ```</p>
    <p>
      The element was removed, but the array still has 3 elements, we can see
      that <code>arr.length == 3</code>.
    </p>
    <p>
      That’s natural, because <code>delete obj.key</code> removes a value by the
      <code>key</code>. It’s all it does. Fine for objects. But for arrays we
      usually want the rest of elements to shift and occupy the freed place. We
      expect to have a shorter array now.
    </p>
    <p>So, special methods should be used.</p>
    <p>
      The <a href="mdn:js/Array/splice">arr.splice</a> method is a swiss army
      knife for arrays. It can do everything: insert, remove and replace
      elements.
    </p>
    <p>The syntax is:</p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="va">arr</span>.<span class="at">splice</span>(start[<span class="op">,</span> deleteCount<span class="op">,</span> elem1<span class="op">,</span> ...<span class="op">,</span> elemN])</a></code></pre>
    </div>
    <p>
      It modifies <code>arr</code> starting from the index <code>start</code>:
      removes <code>deleteCount</code> elements and then inserts
      <code>elem1, ..., elemN</code> at their place. Returns the array of
      removed elements.
    </p>
    <p>This method is easy to grasp by examples.</p>
    <p>Let’s start with the deletion:</p>
    <p>```js run let arr = [“I”, “study”, “JavaScript”];</p>
    <p>
      <em>!</em> arr.splice(1, 1); // from index 1 remove 1 element <em>/!</em>
    </p>
    <p>alert( arr ); // [“I”, “JavaScript”] ```</p>
    <p>
      Easy, right? Starting from the index <code>1</code> it removed
      <code>1</code> element.
    </p>
    <p>
      In the next example we remove 3 elements and replace them with the other
      two:
    </p>
    <p>
      ```js run let arr = [<em>!</em>“I”, “study”, “JavaScript”,<em>/!</em>
      “right”, “now”];
    </p>
    <p>
      // remove 3 first elements and replace them with another arr.splice(0, 3,
      “Let’s”, “dance”);
    </p>
    <p>
      alert( arr ) // now [<em>!</em>“Let’s”, “dance”<em>/!</em>, “right”,
      “now”] ```
    </p>
    <p>
      Here we can see that <code>splice</code> returns the array of removed
      elements:
    </p>
    <p>
      ```js run let arr = [<em>!</em>“I”, “study”,<em>/!</em> “JavaScript”,
      “right”, “now”];
    </p>
    <p>// remove 2 first elements let removed = arr.splice(0, 2);</p>
    <p>alert( removed ); // “I”, “study” &lt;– array of removed elements ```</p>
    <p>
      The <code>splice</code> method is also able to insert the elements without
      any removals. For that we need to set <code>deleteCount</code> to
      <code>0</code>:
    </p>
    <p>```js run let arr = [“I”, “study”, “JavaScript”];</p>
    <p>
      // from index 2 // delete 0 // then insert “complex” and “language”
      arr.splice(2, 0, “complex”, “language”);
    </p>
    <p>alert(arr); // “I”, “study”, “complex”, “language”, “JavaScript” ```</p>
    <p>
      ````smart header=“Negative indexes allowed” Here and in other array
      methods, negative indexes are allowed. They specify the position from the
      end of the array, like here:
    </p>
    <p>```js run let arr = [1, 2, 5];</p>
    <p>
      // from index -1 (one step from the end) // delete 0 elements, // then
      insert 3 and 4 arr.splice(-1, 0, 3, 4);
    </p>
    <p>alert( arr ); // 1,2,3,4,5</p>
    <pre><code></code></pre>
    <h3 id="slice">slice</h3>
    <p>
      The method <a href="mdn:js/Array/slice">arr.slice</a> is much simpler than
      similar-looking <code>arr.splice</code>.
    </p>
    <p>The syntax is:</p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="va">arr</span>.<span class="at">slice</span>([start]<span class="op">,</span> [end])<span class="op">;</span></a></code></pre>
    </div>
    <p>
      It returns a new array copying to it all items from index
      <code>start</code> to <code>end</code> (not including <code>end</code>).
      Both <code>start</code> and <code>end</code> can be negative, in that case
      position from array end is assumed.
    </p>
    <p>
      It’s similar to a string method <code>str.slice</code>, but instead of
      substrings it makes subarrays.
    </p>
    <p>For instance:</p>
    <p>```js run let arr = [“t”, “e”, “s”, “t”];</p>
    <p>alert(arr.slice(1, 3)); // e,s (copy from 1 to 3)</p>
    <p>alert(arr.slice(-2)); // s,t (copy from -2 till the end) ```</p>
    <p>
      We can also call it without arguments: <code>arr.slice()</code> creates a
      copy of <code>arr</code>. That’s often used to obtain a copy for further
      transformations that should not affect the original array.
    </p>
    <h3 id="concat">concat</h3>
    <p>
      The method <a href="mdn:js/Array/concat">arr.concat</a> creates a new
      array that includes values from other arrays and additional items.
    </p>
    <p>The syntax is:</p>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="va">arr</span>.<span class="at">concat</span>(arg1<span class="op">,</span> <span class="va">arg2</span>...)</a></code></pre>
    </div>
    <p>It accepts any number of arguments – either arrays or values.</p>
    <p>
      The result is a new array containing items from <code>arr</code>, then
      <code>arg1</code>, <code>arg2</code> etc.
    </p>
    <p>
      If an argument <code>argN</code> is an array, then all its elements are
      copied. Otherwise, the argument itself is copied.
    </p>
    <p>For instance:</p>
    <p>```js run let arr = [1, 2];</p>
    <p>
      // create an array from: arr and [3,4] alert(arr.concat([3, 4])); //
      1,2,3,4
    </p>
    <p>
      // create an array from: arr and [3,4] and [5,6] alert(arr.concat([3, 4],
      [5, 6])); // 1,2,3,4,5,6
    </p>
    <p>
      // create an array from: arr and [3,4], then add values 5 and 6
      alert(arr.concat([3, 4], 5, 6)); // 1,2,3,4,5,6 ```
    </p>
    <p>
      Normally, it only copies elements from arrays. Other objects, even if they
      look like arrays, are added as a whole:
    </p>
    <p>```js run let arr = [1, 2];</p>
    <p>let arrayLike = { 0: “something”, length: 1, };</p>
    <p>alert(arr.concat(arrayLike)); // 1,2,[object Object] ```</p>
    <p>
      …But if an array-like object has a special
      <code>Symbol.isConcatSpreadable</code> property, then it’s treated as an
      array by <code>concat</code>: its elements are added instead:
    </p>
    <p>```js run let arr = [1, 2];</p>
    <p>
      let arrayLike = { 0: “something”, 1: “else”,
      <em>!</em> [Symbol.isConcatSpreadable]: true, <em>/!</em> length: 2 };
    </p>
    <p>alert( arr.concat(arrayLike) ); // 1,2,something,else ```</p>
    <h2 id="iterate-foreach">Iterate: forEach</h2>
    <p>
      The <a href="mdn:js/Array/forEach">arr.forEach</a> method allows to run a
      function for every element of the array.
    </p>
    <p>The syntax:</p>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="va">arr</span>.<span class="at">forEach</span>(<span class="kw">function</span> (item<span class="op">,</span> index<span class="op">,</span> array) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-2" title="2">  <span class="co">// ... do something with item</span></a>
<a class="sourceLine" id="cb5-3" title="3"><span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <p>For instance, this shows each element of the array:</p>
    <p>
      <code
        >js run // for each element call alert ["Bilbo", "Gandalf",
        "Nazgul"].forEach(alert);</code
      >
    </p>
    <p>
      And this code is more elaborate about their positions in the target array:
    </p>
    <p>
      <code
        >js run ["Bilbo", "Gandalf", "Nazgul"].forEach((item, index, array)
        =&gt; { alert(`${item} is at index ${index} in ${array}`); });</code
      >
    </p>
    <p>
      The result of the function (if it returns any) is thrown away and ignored.
    </p>
    <h2 id="searching-in-array">Searching in array</h2>
    <p>Now let’s cover methods that search in an array.</p>
    <h3 id="indexoflastindexof-and-includes">
      indexOf/lastIndexOf and includes
    </h3>
    <p>
      The methods <a href="mdn:js/Array/indexOf">arr.indexOf</a>,
      <a href="mdn:js/Array/lastIndexOf">arr.lastIndexOf</a> and
      <a href="mdn:js/Array/includes">arr.includes</a> have the same syntax and
      do essentially the same as their string counterparts, but operate on items
      instead of characters:
    </p>
    <ul>
      <li>
        <code>arr.indexOf(item, from)</code> – looks for
        <code>item</code> starting from index <code>from</code>, and returns the
        index where it was found, otherwise <code>-1</code>.
      </li>
      <li>
        <code>arr.lastIndexOf(item, from)</code> – same, but looks for from
        right to left.
      </li>
      <li>
        <code>arr.includes(item, from)</code> – looks for
        <code>item</code> starting from index <code>from</code>, returns
        <code>true</code> if found.
      </li>
    </ul>
    <p>For instance:</p>
    <p>```js run let arr = [1, 0, false];</p>
    <p>
      alert(arr.indexOf(0)); // 1 alert(arr.indexOf(false)); // 2
      alert(arr.indexOf(null)); // -1
    </p>
    <p>alert(arr.includes(1)); // true ```</p>
    <p>
      Note that the methods use <code>===</code> comparison. So, if we look for
      <code>false</code>, it finds exactly <code>false</code> and not the zero.
    </p>
    <p>
      If we want to check for inclusion, and don’t want to know the exact index,
      then <code>arr.includes</code> is preferred.
    </p>
    <p>
      Also, a very minor difference of <code>includes</code> is that it
      correctly handles <code>NaN</code>, unlike
      <code>indexOf/lastIndexOf</code>:
    </p>
    <p>
      <code
        >js run const arr = [NaN]; alert(arr.indexOf(NaN)); // -1 (should be 0,
        but === equality doesn't work for NaN) alert(arr.includes(NaN)); // true
        (correct)</code
      >
    </p>
    <h3 id="find-and-findindex">find and findIndex</h3>
    <p>
      Imagine we have an array of objects. How do we find an object with the
      specific condition?
    </p>
    <p>
      Here the <a href="mdn:js/Array/find">arr.find(fn)</a> method comes in
      handy.
    </p>
    <p>The syntax is:</p>
    <div class="sourceCode" id="cb6">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb6-1" title="1"><span class="kw">let</span> result <span class="op">=</span> <span class="va">arr</span>.<span class="at">find</span>(<span class="kw">function</span> (item<span class="op">,</span> index<span class="op">,</span> array) <span class="op">{</span></a>
<a class="sourceLine" id="cb6-2" title="2">  <span class="co">// if true is returned, item is returned and iteration is stopped</span></a>
<a class="sourceLine" id="cb6-3" title="3">  <span class="co">// for falsy scenario returns undefined</span></a>
<a class="sourceLine" id="cb6-4" title="4"><span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <p>The function is called for elements of the array, one after another:</p>
    <ul>
      <li><code>item</code> is the element.</li>
      <li><code>index</code> is its index.</li>
      <li><code>array</code> is the array itself.</li>
    </ul>
    <p>
      If it returns <code>true</code>, the search is stopped, the
      <code>item</code> is returned. If nothing found, <code>undefined</code> is
      returned.
    </p>
    <p>
      For example, we have an array of users, each with the fields
      <code>id</code> and <code>name</code>. Let’s find the one with
      <code>id == 1</code>:
    </p>
    <p>
      ```js run let users = [ { id: 1, name: “John” }, { id: 2, name: “Pete” },
      { id: 3, name: “Mary” },];
    </p>
    <p>let user = users.find((item) =&gt; item.id == 1);</p>
    <p>alert(user.name); // John ```</p>
    <p>
      In real life arrays of objects is a common thing, so the
      <code>find</code> method is very useful.
    </p>
    <p>
      Note that in the example we provide to <code>find</code> the function
      <code>item =&gt; item.id == 1</code> with one argument. That’s typical,
      other arguments of this function are rarely used.
    </p>
    <p>
      The <a href="mdn:js/Array/findIndex">arr.findIndex</a> method is
      essentially the same, but it returns the index where the element was found
      instead of the element itself and <code>-1</code> is returned when nothing
      is found.
    </p>
    <h3 id="filter">filter</h3>
    <p>
      The <code>find</code> method looks for a single (first) element that makes
      the function return <code>true</code>.
    </p>
    <p>
      If there may be many, we can use
      <a href="mdn:js/Array/filter">arr.filter(fn)</a>.
    </p>
    <p>
      The syntax is similar to <code>find</code>, but
      <code>filter</code> returns an array of all matching elements:
    </p>
    <div class="sourceCode" id="cb7">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb7-1" title="1"><span class="kw">let</span> results <span class="op">=</span> <span class="va">arr</span>.<span class="at">filter</span>(<span class="kw">function</span> (item<span class="op">,</span> index<span class="op">,</span> array) <span class="op">{</span></a>
<a class="sourceLine" id="cb7-2" title="2">  <span class="co">// if true item is pushed to results and the iteration continues</span></a>
<a class="sourceLine" id="cb7-3" title="3">  <span class="co">// returns empty array if nothing found</span></a>
<a class="sourceLine" id="cb7-4" title="4"><span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <p>For instance:</p>
    <p>
      ```js run let users = [ { id: 1, name: “John” }, { id: 2, name: “Pete” },
      { id: 3, name: “Mary” },];
    </p>
    <p>
      // returns array of the first two users let someUsers =
      users.filter((item) =&gt; item.id &lt; 3);
    </p>
    <p>alert(someUsers.length); // 2 ```</p>
    <h2 id="transform-an-array">Transform an array</h2>
    <p>Let’s move on to methods that transform and reorder an array.</p>
    <h3 id="map">map</h3>
    <p>
      The <a href="mdn:js/Array/map">arr.map</a> method is one of the most
      useful and often used.
    </p>
    <p>
      It calls the function for each element of the array and returns the array
      of results.
    </p>
    <p>The syntax is:</p>
    <div class="sourceCode" id="cb8">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb8-1" title="1"><span class="kw">let</span> result <span class="op">=</span> <span class="va">arr</span>.<span class="at">map</span>(<span class="kw">function</span> (item<span class="op">,</span> index<span class="op">,</span> array) <span class="op">{</span></a>
<a class="sourceLine" id="cb8-2" title="2">  <span class="co">// returns the new value instead of item</span></a>
<a class="sourceLine" id="cb8-3" title="3"><span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <p>For instance, here we transform each element into its length:</p>
    <p>
      <code
        >js run let lengths = ["Bilbo", "Gandalf", "Nazgul"].map((item) =&gt;
        item.length); alert(lengths); // 5,7,6</code
      >
    </p>
    <h3 id="sortfn">sort(fn)</h3>
    <p>
      The call to <a href="mdn:js/Array/sort">arr.sort()</a> sorts the array
      <em>in place</em>, changing its element order.
    </p>
    <p>
      It also returns the sorted array, but the returned value is usually
      ignored, as <code>arr</code> itself is modified.
    </p>
    <p>For instance:</p>
    <p>```js run let arr = [1, 2, 15];</p>
    <p>// the method reorders the content of arr arr.sort();</p>
    <p>alert(arr); // <em>!</em>1, 15, 2<em>/!</em> ```</p>
    <p>Did you notice anything strange in the outcome?</p>
    <p>The order became <code>1, 15, 2</code>. Incorrect. But why?</p>
    <p><strong>The items are sorted as strings by default.</strong></p>
    <p>
      Literally, all elements are converted to strings for comparisons. For
      strings, lexicographic ordering is applied and indeed
      <code>"2" &gt; "15"</code>.
    </p>
    <p>
      To use our own sorting order, we need to supply a function as the argument
      of <code>arr.sort()</code>.
    </p>
    <p>The function should compare two arbitrary values and return:</p>
    <div class="sourceCode" id="cb9">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb9-1" title="1"><span class="kw">function</span> <span class="at">compare</span>(a<span class="op">,</span> b) <span class="op">{</span></a>
<a class="sourceLine" id="cb9-2" title="2">  <span class="cf">if</span> (a <span class="op">&gt;</span> b) <span class="cf">return</span> <span class="dv">1</span><span class="op">;</span> <span class="co">// if the first value is greater than the second</span></a>
<a class="sourceLine" id="cb9-3" title="3">  <span class="cf">if</span> (a <span class="op">==</span> b) <span class="cf">return</span> <span class="dv">0</span><span class="op">;</span> <span class="co">// if values are equal</span></a>
<a class="sourceLine" id="cb9-4" title="4">  <span class="cf">if</span> (a <span class="op">&lt;</span> b) <span class="cf">return</span> <span class="dv">-1</span><span class="op">;</span> <span class="co">// if the first value is less than the second</span></a>
<a class="sourceLine" id="cb9-5" title="5"><span class="op">}</span></a></code></pre>
    </div>
    <p>For instance, to sort as numbers:</p>
    <p>
      ```js run function compareNumeric(a, b) { if (a &gt; b) return 1; if (a ==
      b) return 0; if (a &lt; b) return -1; }
    </p>
    <p>let arr = [ 1, 2, 15 ];</p>
    <p><em>!</em> arr.sort(compareNumeric); <em>/!</em></p>
    <p>alert(arr); // <em>!</em>1, 2, 15<em>/!</em> ```</p>
    <p>Now it works as intended.</p>
    <p>
      Let’s step aside and think what’s happening. The <code>arr</code> can be
      array of anything, right? It may contain numbers or strings or objects or
      whatever. We have a set of <em>some items</em>. To sort it, we need an
      <em>ordering function</em> that knows how to compare its elements. The
      default is a string order.
    </p>
    <p>
      The <code>arr.sort(fn)</code> method implements a generic sorting
      algorithm. We don’t need to care how it internally works (an optimized
      <a href="https://en.wikipedia.org/wiki/Quicksort">quicksort</a> or
      <a href="https://en.wikipedia.org/wiki/Timsort">Timsort</a> most of the
      time). It will walk the array, compare its elements using the provided
      function and reorder them, all we need is to provide the
      <code>fn</code> which does the comparison.
    </p>
    <p>
      By the way, if we ever want to know which elements are compared – nothing
      prevents from alerting them:
    </p>
    <p>
      <code
        >js run [1, -2, 15, 2, 0, 8].sort(function (a, b) { alert(a + " &lt;&gt;
        " + b); return a - b; });</code
      >
    </p>
    <p>
      The algorithm may compare an element with multiple others in the process,
      but it tries to make as few comparisons as possible.
    </p>
    <p>
      ````smart header=“A comparison function may return any number” Actually, a
      comparison function is only required to return a positive number to say
      “greater” and a negative number to say “less”.
    </p>
    <p>That allows to write shorter functions:</p>
    <p>```js run let arr = [ 1, 2, 15 ];</p>
    <p>arr.sort(function(a, b) { return a - b; });</p>
    <p>alert(arr); // <em>!</em>1, 2, 15<em>/!</em></p>
    <pre><code></code></pre>
    <p>
      ````smart header=“Arrow functions for the best” Remember
      <a href="info:arrow-functions-basics">arrow functions</a>? We can use them
      here for neater sorting:
    </p>
    <div class="sourceCode" id="cb11">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb11-1" title="1"><span class="va">arr</span>.<span class="at">sort</span>( (a<span class="op">,</span> b) <span class="kw">=&gt;</span> a <span class="op">-</span> b )<span class="op">;</span></a></code></pre>
    </div>
    <p>This works exactly the same as the longer version above. ````</p>
    <p>
      ```<code>smart header="Use</code>localeCompare` for strings" Remember
      <a href="info:string#correct-comparisons">strings</a> comparison
      algorithm? It compares letters by their codes by default.
    </p>
    <p>
      For many alphabets, it’s better to use
      <code>str.localeCompare</code> method to correctly sort letters, such as
      <code>Ö</code>.
    </p>
    <p>For example, let’s sort a few countries in German:</p>
    <p>```js run let countries = [“Österreich”, “Andorra”, “Vietnam”];</p>
    <p>
      alert(countries.sort((a, b) =&gt; (a &gt; b ? 1 : -1))); // Andorra,
      Vietnam, Österreich (wrong)
    </p>
    <p>
      alert(countries.sort((a, b) =&gt; a.localeCompare(b))); //
      Andorra,Österreich,Vietnam (correct!)
    </p>
    <pre><code></code></pre>
    <h3 id="reverse">reverse</h3>
    <p>
      The method <a href="mdn:js/Array/reverse">arr.reverse</a> reverses the
      order of elements in <code>arr</code>.
    </p>
    <p>For instance:</p>
    <p>```js run let arr = [1, 2, 3, 4, 5]; arr.reverse();</p>
    <p>alert( arr ); // 5,4,3,2,1 ```</p>
    <p>It also returns the array <code>arr</code> after the reversal.</p>
    <h3 id="split-and-join">split and join</h3>
    <p>
      Here’s the situation from real life. We are writing a messaging app, and
      the person enters the comma-delimited list of receivers:
      <code>John, Pete, Mary</code>. But for us an array of names would be much
      more comfortable than a single string. How to get it?
    </p>
    <p>
      The <a href="mdn:js/String/split">str.split(delim)</a> method does exactly
      that. It splits the string into an array by the given delimiter
      <code>delim</code>.
    </p>
    <p>In the example below, we split by a comma followed by space:</p>
    <p>```js run let names = ‘Bilbo, Gandalf, Nazgul’;</p>
    <p>let arr = names.split(‘,’);</p>
    <p>
      for (let name of arr) { alert( <code>A message to ${name}.</code> ); // A
      message to Bilbo (and other names) } ```
    </p>
    <p>
      The <code>split</code> method has an optional second numeric argument – a
      limit on the array length. If it is provided, then the extra elements are
      ignored. In practice it is rarely used though:
    </p>
    <p>```js run let arr = ‘Bilbo, Gandalf, Nazgul, Saruman’.split(‘,’, 2);</p>
    <p>alert(arr); // Bilbo, Gandalf ```</p>
    <p>
      ```<code>smart header="Split into letters" The call to</code>split(s)<code
        >with an empty</code
      >s` would split the string into an array of letters:
    </p>
    <p>```js run let str = “test”;</p>
    <p>alert( str.split(’’) ); // t,e,s,t</p>
    <pre><code></code></pre>
    <p>
      The call <a href="mdn:js/Array/join">arr.join(glue)</a> does the reverse
      to <code>split</code>. It creates a string of <code>arr</code> items
      joined by <code>glue</code> between them.
    </p>
    <p>For instance:</p>
    <p>```js run let arr = [“Bilbo”, “Gandalf”, “Nazgul”];</p>
    <p>let str = arr.join(“;”); // glue the array into a string using ;</p>
    <p>alert(str); // Bilbo;Gandalf;Nazgul ```</p>
    <h3 id="reducereduceright">reduce/reduceRight</h3>
    <p>
      When we need to iterate over an array – we can use <code>forEach</code>,
      <code>for</code> or <code>for..of</code>.
    </p>
    <p>
      When we need to iterate and return the data for each element – we can use
      <code>map</code>.
    </p>
    <p>
      The methods <a href="mdn:js/Array/reduce">arr.reduce</a> and
      <a href="mdn:js/Array/reduceRight">arr.reduceRight</a> also belong to that
      breed, but are a little bit more intricate. They are used to calculate a
      single value based on the array.
    </p>
    <p>The syntax is:</p>
    <div class="sourceCode" id="cb14">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb14-1" title="1"><span class="kw">let</span> value <span class="op">=</span> <span class="va">arr</span>.<span class="at">reduce</span>(</a>
<a class="sourceLine" id="cb14-2" title="2">  <span class="kw">function</span> (accumulator<span class="op">,</span> item<span class="op">,</span> index<span class="op">,</span> array) <span class="op">{</span></a>
<a class="sourceLine" id="cb14-3" title="3">    <span class="co">// ...</span></a>
<a class="sourceLine" id="cb14-4" title="4">  <span class="op">},</span></a>
<a class="sourceLine" id="cb14-5" title="5">  [initial]</a>
<a class="sourceLine" id="cb14-6" title="6">)<span class="op">;</span></a></code></pre>
    </div>
    <p>
      The function is applied to all array elements one after another and
      “carries on” its result to the next call.
    </p>
    <p>Arguments:</p>
    <ul>
      <li>
        <code>accumulator</code> – is the result of the previous function call,
        equals <code>initial</code> the first time (if <code>initial</code> is
        provided).
      </li>
      <li><code>item</code> – is the current array item.</li>
      <li><code>index</code> – is its position.</li>
      <li><code>array</code> – is the array.</li>
    </ul>
    <p>
      As function is applied, the result of the previous function call is passed
      to the next one as the first argument.
    </p>
    <p>
      So, the first argument is essentially the accumulator that stores the
      combined result of all previous executions. And at the end it becomes the
      result of <code>reduce</code>.
    </p>
    <p>Sounds complicated?</p>
    <p>The easiest way to grasp that is by example.</p>
    <p>Here we get a sum of an array in one line:</p>
    <p>```js run let arr = [1, 2, 3, 4, 5];</p>
    <p>let result = arr.reduce((sum, current) =&gt; sum + current, 0);</p>
    <p>alert(result); // 15 ```</p>
    <p>
      The function passed to <code>reduce</code> uses only 2 arguments, that’s
      typically enough.
    </p>
    <p>Let’s see the details of what’s going on.</p>
    <ol type="1">
      <li>
        On the first run, <code>sum</code> is the <code>initial</code> value
        (the last argument of <code>reduce</code>), equals <code>0</code>, and
        <code>current</code> is the first array element, equals <code>1</code>.
        So the function result is <code>1</code>.
      </li>
      <li>
        On the second run, <code>sum = 1</code>, we add the second array element
        (<code>2</code>) to it and return.
      </li>
      <li>
        On the 3rd run, <code>sum = 3</code> and we add one more element to it,
        and so on…
      </li>
    </ol>
    <p>The calculation flow:</p>
    <p><img src="reduce.svg" /></p>
    <p>
      Or in the form of a table, where each row represents a function call on
      the next array element:
    </p>
    <table>
      <thead>
        <tr class="header">
          <th></th>
          <th><code>sum</code></th>
          <th><code>current</code></th>
          <th>result</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td>the first call</td>
          <td><code>0</code></td>
          <td><code>1</code></td>
          <td><code>1</code></td>
        </tr>
        <tr class="even">
          <td>the second call</td>
          <td><code>1</code></td>
          <td><code>2</code></td>
          <td><code>3</code></td>
        </tr>
        <tr class="odd">
          <td>the third call</td>
          <td><code>3</code></td>
          <td><code>3</code></td>
          <td><code>6</code></td>
        </tr>
        <tr class="even">
          <td>the fourth call</td>
          <td><code>6</code></td>
          <td><code>4</code></td>
          <td><code>10</code></td>
        </tr>
        <tr class="odd">
          <td>the fifth call</td>
          <td><code>10</code></td>
          <td><code>5</code></td>
          <td><code>15</code></td>
        </tr>
      </tbody>
    </table>
    <p>
      Here we can clearly see how the result of the previous call becomes the
      first argument of the next one.
    </p>
    <p>We also can omit the initial value:</p>
    <p>```js run let arr = [1, 2, 3, 4, 5];</p>
    <p>
      // removed initial value from reduce (no 0) let result = arr.reduce((sum,
      current) =&gt; sum + current);
    </p>
    <p>alert(result); // 15 ```</p>
    <p>
      The result is the same. That’s because if there’s no initial, then
      <code>reduce</code> takes the first element of the array as the initial
      value and starts the iteration from the 2nd element.
    </p>
    <p>The calculation table is the same as above, minus the first row.</p>
    <p>
      But such use requires an extreme care. If the array is empty, then
      <code>reduce</code> call without initial value gives an error.
    </p>
    <p>Here’s an example:</p>
    <p>```js run let arr = [];</p>
    <p>
      // Error: Reduce of empty array with no initial value // if the initial
      value existed, reduce would return it for the empty arr. arr.reduce((sum,
      current) =&gt; sum + current); ```
    </p>
    <p>So it’s advised to always specify the initial value.</p>
    <p>
      The method <a href="mdn:js/Array/reduceRight">arr.reduceRight</a> does the
      same, but goes from right to left.
    </p>
    <h2 id="array.isarray">Array.isArray</h2>
    <p>
      Arrays do not form a separate language type. They are based on objects.
    </p>
    <p>
      So <code>typeof</code> does not help to distinguish a plain object from an
      array:
    </p>
    <p>
      <code>js run alert(typeof {}); // object alert(typeof []); // same</code>
    </p>
    <p>
      …But arrays are used so often that there’s a special method for that:
      <a href="mdn:js/Array/isArray">Array.isArray(value)</a>. It returns
      <code>true</code> if the <code>value</code> is an array, and
      <code>false</code> otherwise.
    </p>
    <p>```js run alert(Array.isArray({})); // false</p>
    <p>alert(Array.isArray([])); // true ```</p>
    <h2 id="most-methods-support-thisarg">Most methods support “thisArg”</h2>
    <p>
      Almost all array methods that call functions – like <code>find</code>,
      <code>filter</code>, <code>map</code>, with a notable exception of
      <code>sort</code>, accept an optional additional parameter
      <code>thisArg</code>.
    </p>
    <p>
      That parameter is not explained in the sections above, because it’s rarely
      used. But for completeness we have to cover it.
    </p>
    <p>Here’s the full syntax of these methods:</p>
    <div class="sourceCode" id="cb15">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb15-1" title="1"><span class="va">arr</span>.<span class="at">find</span>(func<span class="op">,</span> thisArg)<span class="op">;</span></a>
<a class="sourceLine" id="cb15-2" title="2"><span class="va">arr</span>.<span class="at">filter</span>(func<span class="op">,</span> thisArg)<span class="op">;</span></a>
<a class="sourceLine" id="cb15-3" title="3"><span class="va">arr</span>.<span class="at">map</span>(func<span class="op">,</span> thisArg)<span class="op">;</span></a>
<a class="sourceLine" id="cb15-4" title="4"><span class="co">// ...</span></a>
<a class="sourceLine" id="cb15-5" title="5"><span class="co">// thisArg is the optional last argument</span></a></code></pre>
    </div>
    <p>
      The value of <code>thisArg</code> parameter becomes <code>this</code> for
      <code>func</code>.
    </p>
    <p>
      For example, here we use a method of <code>army</code> object as a filter,
      and <code>thisArg</code> passes the context:
    </p>
    <p>
      ```js run let army = { minAge: 18, maxAge: 27, canJoin(user) { return
      user.age &gt;= this.minAge &amp;&amp; user.age &lt; this.maxAge; } };
    </p>
    <p>let users = [ {age: 16}, {age: 20}, {age: 23}, {age: 30}];</p>
    <p>
      <em>!</em> // find users, for who army.canJoin returns true let soldiers =
      users.filter(army.canJoin, army); <em>/!</em>
    </p>
    <p>
      alert(soldiers.length); // 2 alert(soldiers[0].age); // 20
      alert(soldiers[1].age); // 23 ```
    </p>
    <p>
      If in the example above we used <code>users.filter(army.canJoin)</code>,
      then <code>army.canJoin</code> would be called as a standalone function,
      with <code>this=undefined</code>, thus leading to an instant error.
    </p>
    <p>
      A call to <code>users.filter(army.canJoin, army)</code> can be replaced
      with <code>users.filter(user =&gt; army.canJoin(user))</code>, that does
      the same. The latter is used more often, as it’s a bit easier to
      understand for most people.
    </p>
    <h2 id="summary">Summary</h2>
    <p>A cheat sheet of array methods:</p>
    <ul>
      <li>
        <p>To add/remove elements:</p>
        <ul>
          <li><code>push(...items)</code> – adds items to the end,</li>
          <li><code>pop()</code> – extracts an item from the end,</li>
          <li><code>shift()</code> – extracts an item from the beginning,</li>
          <li><code>unshift(...items)</code> – adds items to the beginning.</li>
          <li>
            <code>splice(pos, deleteCount, ...items)</code> – at index
            <code>pos</code> deletes <code>deleteCount</code> elements and
            inserts <code>items</code>.
          </li>
          <li>
            <code>slice(start, end)</code> – creates a new array, copies
            elements from index <code>start</code> till <code>end</code> (not
            inclusive) into it.
          </li>
          <li>
            <code>concat(...items)</code> – returns a new array: copies all
            members of the current one and adds <code>items</code> to it. If any
            of <code>items</code> is an array, then its elements are taken.
          </li>
        </ul>
      </li>
      <li>
        <p>To search among elements:</p>
        <ul>
          <li>
            <code>indexOf/lastIndexOf(item, pos)</code> – look for
            <code>item</code> starting from position <code>pos</code>, return
            the index or <code>-1</code> if not found.
          </li>
          <li>
            <code>includes(value)</code> – returns <code>true</code> if the
            array has <code>value</code>, otherwise <code>false</code>.
          </li>
          <li>
            <code>find/filter(func)</code> – filter elements through the
            function, return first/all values that make it return
            <code>true</code>.
          </li>
          <li>
            <code>findIndex</code> is like <code>find</code>, but returns the
            index instead of a value.
          </li>
        </ul>
      </li>
      <li>
        <p>To iterate over elements:</p>
        <ul>
          <li>
            <code>forEach(func)</code> – calls <code>func</code> for every
            element, does not return anything.
          </li>
        </ul>
      </li>
      <li>
        <p>To transform the array:</p>
        <ul>
          <li>
            <code>map(func)</code> – creates a new array from results of calling
            <code>func</code> for every element.
          </li>
          <li>
            <code>sort(func)</code> – sorts the array in-place, then returns it.
          </li>
          <li>
            <code>reverse()</code> – reverses the array in-place, then returns
            it.
          </li>
          <li><code>split/join</code> – convert a string to array and back.</li>
          <li>
            <code>reduce/reduceRight(func, initial)</code> – calculate a single
            value over the array by calling <code>func</code> for each element
            and passing an intermediate result between the calls.
          </li>
        </ul>
      </li>
      <li>
        Additionally:
        <ul>
          <li>
            <code>Array.isArray(arr)</code> checks <code>arr</code> for being an
            array.
          </li>
        </ul>
      </li>
    </ul>
    <p>
      Please note that methods <code>sort</code>, <code>reverse</code> and
      <code>splice</code> modify the array itself.
    </p>
    <p>
      These methods are the most used ones, they cover 99% of use cases. But
      there are few others:
    </p>
    <ul>
      <li>
        <p>
          <a href="mdn:js/Array/some">arr.some(fn)</a>/<a
            href="mdn:js/Array/every"
            >arr.every(fn)</a
          >
          check the array.
        </p>
        <p>
          The function <code>fn</code> is called on each element of the array
          similar to <code>map</code>. If any/all results are <code>true</code>,
          returns <code>true</code>, otherwise <code>false</code>.
        </p>
        <p>
          These methods behave sort of like <code>||</code> and
          <code>&amp;&amp;</code> operators: if <code>fn</code> returns a truthy
          value, <code>arr.some()</code> immediately returns
          <code>true</code> and stops iterating over the rest of items; if
          <code>fn</code> returns a falsy value,
          <code>arr.every()</code> immediately returns <code>false</code> and
          stops iterating over the rest of items as well.
        </p>
        <p>We can use <code>every</code> to compare arrays:</p>
        <p>
          ```js run function arraysEqual(arr1, arr2) { return ( arr1.length ===
          arr2.length &amp;&amp; arr1.every((value, index) =&gt; value ===
          arr2[index]) ); }
        </p>
        <p>alert(arraysEqual([1, 2], [1, 2])); // true ```</p>
      </li>
      <li>
        <p>
          <a href="mdn:js/Array/fill">arr.fill(value, start, end)</a> – fills
          the array with repeating <code>value</code> from index
          <code>start</code> to <code>end</code>.
        </p>
      </li>
      <li>
        <p>
          <a href="mdn:js/Array/copyWithin"
            >arr.copyWithin(target, start, end)</a
          >
          – copies its elements from position <code>start</code> till position
          <code>end</code> into <em>itself</em>, at position
          <code>target</code> (overwrites existing).
        </p>
      </li>
      <li>
        <p>
          <a href="mdn:js/Array/flat">arr.flat(depth)</a>/<a
            href="mdn:js/Array/flatMap"
            >arr.flatMap(fn)</a
          >
          create a new flat array from a multidimensional array.
        </p>
      </li>
    </ul>
    <p>For the full list, see the <a href="mdn:js/Array">manual</a>.</p>
    <p>
      From the first sight it may seem that there are so many methods, quite
      difficult to remember. But actually that’s much easier.
    </p>
    <p>
      Look through the cheat sheet just to be aware of them. Then solve the
      tasks of this chapter to practice, so that you have experience with array
      methods.
    </p>
    <p>
      Afterwards whenever you need to do something with an array, and you don’t
      know how – come here, look at the cheat sheet and find the right method.
      Examples will help you to write it correctly. Soon you’ll automatically
      remember the methods, without specific efforts from your side.
    </p>
  </body>
</html>
